import { getUserScheduleInTime } from '../../api/request.js'
import { throttle } from './../../utils/utils.js'
import create from 'dd-store'

// 传递给组件toast的所有数据
const conToastData = {
  showToast: false,
  title: '保存成功'
}
create.Page({
  data: {
    $data: null,
    outlookContact: [],
    conflictPeople: [],
    scheduleItem: '',
    // 传递给组件toast的所有数据
    conToastData: conToastData,
    currentPeople: '',
    value: '',
  },
  onLoad(event) {
    const _that = this

    if (event.scheduleItem) {
      let scheduleItem = JSON.parse(event.scheduleItem)
      this.setData({
        scheduleItem: scheduleItem
      })
    }

    let outlookContact = []
    for (let value of this.$store.data.participatorList) {
      if (value.platform === 'outlook') {
        outlookContact.push(value)
      }
    }
    this.setData({
      outlookContact: outlookContact,
      currentPeople: getApp().globalData.userid
    })

    this.conflictPeople()
  },
  onShow() {
  },
  // input 的输入 事件
  onInput(event) {
    this.setData({
      value: event.detail.value
    })
  },
  // 添加email
  addEmail() {
    let reg = /^\w+((.\w+)|(-\w+))@[A-Za-z0-9]+((.|-)[A-Za-z0-9]+).[A-Za-z0-9]+$/
    if (!!this.data.value) {
      if (reg.test(this.data.value)) {
        let outlookContact = this.data.outlookContact
        outlookContact.push({
          userId: this.data.value,
          username: this.data.value,
          headUrl: '',
          platform: 'outlook'
        })
        outlookContact = this.setArrary(outlookContact)
        this.setData({
          value: '',
          outlookContact: outlookContact
        })
        this.conflictPeople()
      }
      else {
        dd.alert({
          content: '请输入正确的邮箱格式',
          buttonText: '确定'
        })
      }
    }
  },
  // 关闭
  close(event) {
    let outlookContact = this.data.outlookContact
    let index = 0
    for (let value of this.data.outlookContact) {
      if (value.userId === event.currentTarget.dataset.item.userId) {
        outlookContact.splice(index, 1)
        this.setData({
          outlookContact: outlookContact
        })
        return
      }
      index++
    }
  },
  // 数组 去重
  setArrary(arr) {
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 创建的时候保存
  createSave() {
    dd.navigateBack({
      delta: 1
    })

  },
  // 编辑的时候保存
  editSave() {
    this.$store.data.updateInfo.isUpate = true
    this.$store.data.updateInfo.updateType = 'operate_user'
    this.update()
    dd.navigateBack({
      delta: 1
    })
  },
  // 保存
  save() {
    this.$store.data.participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
    this.$store.data.participatorUserId.push(getApp().globalData.userid)
    for (let value of this.data.outlookContact) {
      this.$store.data.participatorList.push(value)
      this.$store.data.participatorUserId.push(value.userId)
    }
    this.$store.data.participatorList = this.setArrary(this.$store.data.participatorList)
    this.$store.data.participatorUserId = [...new Set(this.$store.data.participatorUserId)]
    this.update()
    if (!!this.data.scheduleItem) {
      this.editSave()
    } else {
      this.createSave()
    }
  },
  // 选择弹窗
  onSelectPopup(event) {
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'conSelectPopupData.selectPopupId': event.currentTarget.dataset.item.id,
      'centerPopup.showCenterPopup': true
    })
  },
  // toast 消失之后的回调
  onToastHidden() {
    this.setData({
      'conToastData.showToast': false
    })
  },
  // 会议冲突
  conflictPeople() {
    let userIds = []
    for (let value of this.data.outlookContact) {
      userIds.push(value.userId)
    }
    let data = {
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        if (!!this.data.scheduleItem) {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 1) {
            conflictPeople.push(value)
          }

        } else {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 1) {
            conflictPeople.push(value)
          }
        }

      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  },
  // onSelectPopupCancel 点击取消 
  onSelectPopupCancel() {
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'centerPopup.showCenterPopup': false
    })
    this.operateUserE(false)
  },
  // 页面卸载
  onUnload() {


  }

});
