import create from 'dd-store'
import pageStore from './store';
import { checkFullScren } from "../../utils/checkFullScren";

import { modifySchedule, addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'

// 传给组件 hList 水平排列  所有数据 comHListData
const comHListData = {
  contactData: [
    { id: 'dd', text: '钉钉联系人', imageUrl: '../../assests/dingContact.png' },
    { id: 'outlook', text: '手动添加邮箱', imageUrl: '../../assests/emailContact.png' }
  ]
}

// 传给组件 comPopup 的数据
const comPopupData = {
  popupTitle: '添加参会人',
  popupShow: false
}
create.Page({
  data: {
    store: pageStore,
    $data: null,
    scheduleItem: '',
    conflictPeople: [],
    // 登陆当前账户的人 权限
    currentPeople: '',
    comHListData: comHListData,
    comPopupData: comPopupData,
    isClick: false,
    isIPX: false
  },
  onLoad(event) {
    if (event.scheduleItem) {
      let scheduleItem = JSON.parse(event.scheduleItem)
      this.setData({
        scheduleItem: scheduleItem
      })
      // for (let value of this.$store.data.participatorList) {
      //   this.store.data.contactPeople.push(value)
      //   this.store.data.contactPeopleId.push(value.userId)
      //   this.update()
      // }
    }

    this.setData({
      isIPX: checkFullScren(),
      currentPeople: getApp().globalData.userid
    })


  },
  onShow() {

    dd.setNavigationBar({
      title: `参会人(${this.$store.data.participatorList.length}人）`
    })

    this.conflictPeople()

  },

  // 添加参会人 钉钉选人 
  addParticipator() {
    const _that = this
    let require = []
    let select = []
    let outLookConcat = []
    for (let participator of _that.$store.data.participatorList) {
      if (participator.platform === 'outlook') {
        outLookConcat.push(participator)
      }
    }
    if (!_that.data.scheduleItem || this.$store.data.originalData.organizer === getApp().globalData.userid) {
      console.log(_that.$store.data.participatorUserId)
      select = _that.$store.data.participatorUserId
      require = [getApp().globalData.userid]
    } else {
      select = _that.$store.data.participatorUserId
      require = [...this.$store.data.originUsersId]
    }
    select = _that.selectedelRequired([...require], [...select]).pickedUsers

    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        let people = []
        let peopleId = []
        if (!_that.data.scheduleItem || _that.$store.data.originalData.organizer === getApp().globalData.userid) {
          people.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
          res.users.forEach((item, index) => {
            people.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
          })
        } else {
          _that.$store.data.originUsers.forEach((item, index) => {
            people.push(item)
          })
          res.users.forEach((item, index) => {
            people.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
          })
        }
        people = _that.setArrary(people.concat(outLookConcat))
        for (let value of people) {
          peopleId.push(value.userId)
        }
        people = _that.setArrary(people.concat(outLookConcat))
        _that.$store.data.participatorList = people
        _that.$store.data.participatorUserId = peopleId
        _that.update()

      },
      fail: function (err) {
      }
    })
  },
  // 删除参会人
  delParticipants(event) {
    let userId = event.target.dataset.userId
    this.$store.data.participatorList.forEach((item, index) => {
      if (userId === item.userId) {
        let people = [...this.$store.data.participatorList]
        people.splice(index, 1)
        this.$store.data.participatorList = people
        this.update()
        return
      }
    })
    this.$store.data.participatorUserId.forEach((item, index) => {
      if (userId === item) {
        let peopleId = [...this.$store.data.participatorUserId]
        peopleId.splice(index, 1)
        console.log(peopleId)
        this.$store.data.participatorUserId = peopleId
        this.update()
        return
      }
    })
    this.conflictPeople()
  },
  // 编辑时候的保存
  editSave() {
    this.setData({
      isClick: true
    })
    if (this.$store.data.originUsers != this.$store.data.participatorList) {
      this.$store.data.updateInfo.isUpate = true
      this.$store.data.updateInfo.updateType = 'operate_user'
      this.update()
    }
    dd.navigateBack({
      delta: 1
    })
  },

  // 保存信息
  saveInfo() {
    this.editSave()
  },

  // 展示弹窗
  showPopup() {
    this.setData({
      'comPopupData.popupShow': true
    })
  },
  // 隐藏弹窗
  closePopup() {
    this.setData({
      'comPopupData.popupShow': false
    })
  },
  // 选择添加人员的方式
  selectComHList(event) {
    switch (event.currentTarget.dataset.item.id) {
      // 选择dd加人
      case "dd":
        this.setData({
          'comPopupData.popupShow': false
        })
        this.addParticipator()
        break;

      // 选择通过outlook添加邮箱联系人
      case "outlook":
        this.setData({
          'comPopupData.popupShow': false
        })
        dd.navigateTo({ url: `./../outLookContact/outLookContact?scheduleItem=${JSON.stringify(this.data.scheduleItem)}` })
        break;
    }
  },

  // 选择弹窗
  onSelectPopup(event) {
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'conSelectPopupData.selectPopupId': event.currentTarget.dataset.item.id,
      'centerPopup.showCenterPopup': true
    })
  },
  // 数组取差值 原先的数组与现在的比较 增加与减少
  arrayPoor(origin, now) {
    let originMap = new Map()
    let nowMap = new Map()
    let add = []
    let del = []
    for (let x of origin) {
      originMap.set(x.userId, x)
    }
    for (let x of now) {
      nowMap.set(x.userId, x)
      let status1 = originMap.get(x.userId)
      if (!status1) {
        add.push(x)
      }
    }
    for (let x of origin) {
      let status2 = nowMap.get(x.userId)
      if (!status2) {
        del.push(x)
      }
    }
    return {
      addUserList: add,
      deleteUserList: del
    }
  },

  // 数组去重
  setArrary(arr, userId) {
    console.log(arr)
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 会议冲突
  conflictPeople() {
    let userIds = []
    for (let item of this.$store.data.participatorList) {
      userIds.push(item.userId)
    }

    let data = {
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        if (!!this.data.scheduleItem) {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 1) {
            conflictPeople.push(value)
          }
        } else {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 0) {
            conflictPeople.push(value)
          }
        }
      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  },
  // 已选用户去中去掉必选用户
  selectedelRequired([...req], [...pic]) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  },
  // 页面卸载
  onUnload() {
    if (this.data.isClick === false && !!this.data.scheduleItem) {
      this.reSetPeople()
    }
  },
  // 重置人
  reSetPeople() {
    this.$store.data.updateInfo.isUpate = false
    this.$store.data.updateInfo.updateType = ''
    this.$store.data.participatorList = this.$store.data.originUsers
    this.$store.data.participatorUserId = this.$store.data.originUsersId
    this.update()
  }

});
